; main.asm
extern  fopen
extern  fscanf
extern  fclose
extern  printf
extern  stdout
extern  time
extern  srand

extern  InRectangle
extern  InTriangle
extern  InShape
extern  InContainer

extern  InRndRectangle
extern  InRndTriangle
extern  InRndShape
extern  InRndContainer

extern  OutRectangle
extern  OutTriangle
extern  OutShape
extern  OutContainer

extern  PerimeterRectangle
extern  PerimeterTriangle
extern  PerimeterShape
extern  PerimeterContainer

extern  Random

global  RECTANGLE
global  TRIANGLE

section .data
    RECTANGLE   dd  1
    TRIANGLE    dd  2

    rectFile        dq  "tests/rectFile.txt",0    ; имя тестового файла с прямоугольником
    trianFile       dq  "tests/trianFile.txt",0   ; имя тестового файла с треугольником
    shapeRectFile   dq  "tests/shapeRectFile.txt",0    ; имя тестового файла с прямоугольником
    shapeTrianFile  dq  "tests/shapeTrianFile.txt",0   ; имя тестового файла с треугольником
    shapeContFile  dq   "tests/contFile.txt",0   ; имя тестового файла с треугольником
    toRead          db  "r"

    rectOutFmt      db "It is Rectangle: x = %d, y = %d",10,0
    trianOutFmt     db "It is Triangle: a = %d, b = %d, c = %d",10,0
    tagOutFmt       db "Tag is: %d. ",0
    rndNumFmt       db "Random number = %d",10, 0

section .bss
    FILE    resq    1       ; Указатель на FILE
    rShape  resd    1       ; Признак прямоугольника = RECTANGLE
    rect    resd    2       ; x, y
    tShape  resd    1       ; Признак треугольника = TRIANGLE
    trian   resd    3       ; a, b, c
    shape   resd    4       ; случайная фигура
    cont    resb    160     ; буфер, используемый для заполнения фигурами (до 10 фигур)
    len     resd    1       ; число заполненных элементов в контейнере
section .text
    global main
;----------------------------------------------
main:
    push    rbp
    mov     rbp,rsp

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Начальная установка генератора случайных чисел
    xor     rdi, rdi
    xor     rax, rax
    call    time
    mov     rdi, rax
    xor     rax, rax
    call    srand

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Порождение случайных чисел
    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

     call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    call Random
    ; Тестовый вывод случайного числа
    mov     rdi, rndNumFmt
    mov     esi, eax
    xor     rax, 0
    call    printf

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Порождение случайного прямоугольника
    mov     rdi, rect   ; передача адреса прямоугольника
    call    InRndRectangle

    ; Вывод параметров прямоугольника
    mov     rdi, rect
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutRectangle

    ;...............................................................
    ; Порождение случайного треугольника
    mov     rdi, trian   ; передача адреса треугольника
    call    InRndTriangle

    ; Вывод параметров треугольника
    mov     rdi, trian
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutTriangle

    ;...............................................................
    ; Порождение случайного прямоугольника
    mov     rdi, rect   ; передача адреса прямоугольника
    call    InRndRectangle

    ; Вывод параметров прямоугольника
    mov     rdi, rect
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutRectangle

    ;...............................................................
    ; Порождение случайного треугольника
    mov     rdi, trian   ; передача адреса треугольника
    call    InRndTriangle

    ; Вывод параметров треугольника
    mov     rdi, trian
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutTriangle

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Порождение случайной фигуры
    mov     rdi, shape   ; передача адреса фигуры
    call    InRndShape

    ; Вывод параметров фигуры
    mov     rdi, shape
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutShape

    ;...............................................................
    ; Порождение случайной фигуры
    mov     rdi, shape   ; передача адреса фигуры
    call    InRndShape

    ; Вывод параметров фигуры
    mov     rdi, shape
    mov     rsi, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutShape

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ; Заполнение контейнера случайными фигурами
    mov     rdi, cont   ; передача адреса контейнера
    mov     rsi, len    ; передача адреса для длины
    mov     edx, 5      ; передача количества порождаемых фигур
    call    InRndContainer

    ; Вывод содержимого контейнера
    mov     rdi, cont
    mov     esi, [len]
    mov     rdx, [stdout]
    mov     rax, 0              ; нет чисел с плавающей точкой
    call    OutContainer

    ;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ;Завершение программы
    pop     rbp
    mov     rax,60
    mov     rdi,0

syscall
